#ifndef __GS_PROBLEM_LEVEL_H__
#define __GS_PROBLEM_LEVEL_H__

#include "GS_Problem_Defs.h"

class GS_ProblemLevel
{
private:
	GS_Image org;
	GS_Image flt;

	GS_Image data;
	CFloatImage dataW;

	//GF = Gradient Field
	GS_Image orgGF_X;
	GS_Image orgGF_Y;
	GS_Image fltGF_X;
	GS_Image fltGF_Y;

public:
	GS_ProblemLevel();
	void Resize(CShape imgShape);	
	void ComputeGrads();

	void GetData(GS_Image &_org,  GS_Image &_flt,
				 GS_Image &_data, GS_Image &_dataW,
				 GS_Image &_orgGF_X, GS_Image &_orgGF_Y,
		         GS_Image &_fltGF_X, GS_Image &_fltGF_Y);

	void GetDataGF(GS_Image &_orgGF_X, GS_Image &_orgGF_Y,
		           GS_Image &_fltGF_X, GS_Image &_fltGF_Y);

	void Copy(const GS_ProblemLevel& cpySrc, int srcChannel);

private:
	void GetData(GS_Image &_org, GS_Image &_flt,
				 GS_Image &_orgGF_X, GS_Image &_orgGF_Y,
		         GS_Image &_fltGF_X, GS_Image &_fltGF_Y);


public: //GS_Problemlevel-IO.cpp
	void Write(string prefix, int levelFileID, string fileExt = "tga") const;

	void WriteGradImgs(const vector<GS_Image>& imgs, const vector<string>& imgFNs, bool normalizeBeforeDump) const;

	void Read(string prefix, int levelFileID, string fileExt = "raw");					

	friend class GS_ProblemLevels;
	friend class GS_Solver;
	friend class GS_VSolver;
	friend class GS_Problem;
};



#endif

