#pragma once
#include "AbsractPreconditioner.h"

///*
// implementation of the preconditioner described in 
// "Fast Surface Reconstruction Using the Level Set Method"
class PrecondHBF : public AbsractPreconditioner
{
	size_v width, height;
	int levels;
	size_v nodeCount;

public:
	PrecondHBF(size_v _width, size_v _height, int _levels = -1);
	~PrecondHBF(){};

	void Apply(size_v n, precise* vec) const
	{
		INSIST(n == this->nodeCount);
		sweepUp(vec); sweepDown(vec);
	}
	
private:
	static int maxNumberOfLevels(size_v _width, size_v _height);	
	void sweepUp(precise* vec) const;
	void sweepDown(precise* vec) const;
	void sweepUp(precise* vec, int level) const;
	void sweepDown(precise* vec, int level) const;

	size_v nodeIndex(size_v x, size_v y) const
	{
		return (this->width * y) + x;
	}
};
//*/


//#define Areal double
//
//class PrecondHBF :  public AbsractPreconditioner {
//
//
// public:
//
//  PrecondHBF(const int w, const int h, int levels);
//
//
//  	void Apply(size_v n, precise* vec) const
//	{
//		INSIST(n == _w * _h);
//		sweepUp(vec); sweepDown(vec);
//	}
//
//
//  void precondVec(Areal* r) const {
//    sweepUp(r); sweepDown(r);
//  }
//
//
// private:
//
//  void sweepUp(Areal* r) const;
//  void sweepUp(precise* vec, int sourceLevel) const;
//  void sweepDown(Areal* r) const;
//  void sweepDown(Areal* r, int targetLevel) const;
//  Areal* extractMatrix(int which) const;
//  void printMatrix(Areal* m, FILE* fp) const;
//
//  int _w, _h, _xlevels, _ylevels, _maxLevels;
//  
//};


