#ifndef __GSF_COLORIZE_H__
#define __GSF_COLORIZE_H__

#include "GS_Filter.h"

class GSF_Colorize : public GS_Filter
{
public:
	typedef struct _Params 
	{
		double edgeSensitivity;
		bool improvedSDI;
		float bfSpaceS;
		float bfSigS;
		_Params(double _edgeSensitivity = 200, bool _improvedSDI = false, float _bfSpaceS = 0.0f, float _bfSigS = 0.0f)
		{
			this->edgeSensitivity = _edgeSensitivity;
			this->improvedSDI     = _improvedSDI;			
			this->bfSpaceS        = _bfSpaceS;
			this->bfSigS          = _bfSigS;
		}
		static _Params Default();
		void Dump(string prefix);
	}Params;

private:
	Params params;

public:
	GSF_Colorize(GS_Problem *_problem, const Params &_params = Params::Default());
	void FilterLevel(int iLevel, void* userData = NULL);

private:
	string getScribblesFN(string orgFN);

public: //GSF_Colorize-Driver.cpp	

	static GS_Problem::Params GS_Problem_Params_Default();
	static GS_Solver::Params GS_Solver_Params_Default();

	static GS_Image Colorize(GS_ProblemInput probInput,
					         Params fltParams              = Params::Default(),
						     GS_Problem::Params probParams = GS_Problem_Params_Default(),
						     GS_Solver::Params solParams   = GS_Solver_Params_Default());

	static void TestFilters(string imgFN, string outDir = "");
};

#endif
