#ifndef __GSF_DEBLOCK_H__
#define __GSF_DEBLOCK_H__

#include "GS_Filter.h"
#include "Curve.h"

class GSF_Deblock : public GS_Filter
{
public:

	typedef struct _Params 
	{
		Curve blockGradCurve;
		float uvMult;
		_Params(Curve _blockGradCurve = Curve(), float _uvMult = 10.0f)
		{
			this->blockGradCurve = _blockGradCurve;
			this->uvMult         = _uvMult;
		}
		static _Params Default();
		void Dump(string prefix);
	}Params;

private:
	Params params;

public:
	GSF_Deblock(GS_Problem *_problem, const Params &_params = Params::Default());
	void FilterLevel(int iLevel, void* userData = NULL);

	Params GetParams()
	{
		return params;
	}

private:
	string getScribblesFN(string orgFN);

public: //GSF_Deblock-Driver.cpp	

	static GS_Problem::Params GS_Problem_Params_Default();
	static GS_Solver::Params GS_Solver_Params_Default();

	static GS_Image Deblock(GS_ProblemInput probInput,
					     Params fltParams              = Params::Default(),
						 GS_Problem::Params probParams = GS_Problem_Params_Default(),
						 GS_Solver::Params solParams   = GS_Solver_Params_Default());


	static void TestFilters(string imgFN, string outDir = "");
};

#endif

