#include "GS_Filter.h"

GS_Filter::GS_Filter(GS_Problem* _problem)
{
	this->problem = _problem;
}


GS_Filter::~GS_Filter()
{
}

void GS_Filter::Filter(void* userData)
{
	INSIST(this->problem->GetLevelCount() > 0);

	for(int iLevel = 0; iLevel < this->problem->GetLevelCount(); iLevel++)
	{
		FilterLevel(iLevel, userData);
	}
}


void GS_Filter::Filter(Indices levelsToFilter, void* userData)
{
	INSIST(this->problem->GetLevelCount() > 0);
	INSIST(levelsToFilter.size() > 0);

	for(Indices::const_iterator iLevel = levelsToFilter.begin();
		iLevel != levelsToFilter.end();
		iLevel++)
	{
		FilterLevel(*iLevel, userData);
	}
}

