#include "GSF_GradCurve.h"

GSF_GradCurve::Params GSF_GradCurve::Params::Default()
{
	Params params;
	return params;
}

GSF_GradCurve::Params GSF_GradCurve::Params::Sharpen()
{
	Params params;
	string curveStr = "500 0.000000e+000 1.50000e+000 2 "
					  "0.000000e+000 0.000000e+000 "
					  "1.000000e+000 1.000000e+000 ";
	params.gradCurve.Load(curveStr);
	return params;
}

GSF_GradCurve::Params GSF_GradCurve::Params::Blur()
{
	Params params;
	string curveStr = "500 0.000000e+000 7.50000e-001 2 "
					  "0.000000e+000 0.000000e+000 "
					  "1.000000e+000 1.000000e+000 ";
	params.gradCurve.Load(curveStr);
	return params;
}


GSF_GradCurve::Params GSF_GradCurve::Params::SmartSharpen()
{
	Params params;
	string curveStr = "500 0.000000e+000 1.750000e+000 5 "
					  "0.000000e+000 0.000000e+000 "
					  "6.000000e-003 5.714000e-005 "
					  "1.600000e-001 9.142000e-002 "
					  "3.750000e-001 2.857000e-001 "
					  "1.000000e+000 1.000000e+000 ";
	params.gradCurve.Load(curveStr);
	return params;
}

GSF_GradCurve::Params GSF_GradCurve::Params::NPR()
{
	Params params;
	string curveStr = "500 0.000000e+000 1.750000e+000 5 "
					  "0.000000e+000 0.000000e+000 "
					  "6.000000e-002 5.714000e-005 "
					  "1.827957e-001 9.392265e-002 "
					  "3.750000e-001 2.857000e-001 "
					  "1.000000e+000 1.000000e+000 ";
	params.gradCurve.Load(curveStr);
	return params;
}

void GSF_GradCurve::Params::Dump(string prefix)
{
	const char* prefixPtr = prefix.c_str();

	printf("\n");
	printf("%s GSF gradient curve params:\n", prefixPtr);

	printf("%s gradient curve: \n", prefixPtr);
	this->gradCurve.Dump(prefix + "   ");

	printf("\n");
}


