#include "GSF_MotionBlur.h"

GSF_MotionBlur::Params GSF_MotionBlur::Params::Default()
{
	Params params(0.1f, 0.1f, 5.0f);
	CHECK_RANGE(params.minGradWeight, 0.0f, 1.0f);
	return params;
}

void GSF_MotionBlur::Params::Dump(string prefix)
{
	const char* prefixPtr = prefix.c_str();

	printf("\n");
	printf("%s GSF Motion Blur params:\n", prefixPtr);

	printf("%s   minGradWeight - %f\n", prefixPtr, this->minGradWeight);
	printf("%s   flowCnfScale  - %f\n", prefixPtr, this->flowCnfScale);
	printf("%s   flowLenScale  - %f\n", prefixPtr, this->flowLenScale);

	printf("\n");
}


