#ifndef __GSF_MOTION_BLUR_H__
#define __GSF_MOTION_BLUR_H__

#include "GS_Filter.h"

class GSF_MotionBlur : public GS_Filter
{
public:
	typedef struct _Params 
	{
		float minGradWeight;
		float flowCnfScale;
		float flowLenScale;

		_Params(float _minGradWeight = 0.25f,
				float _flowCnfScale  = 1.0f,
				float _flowLenScale  = 1.0f)
		{
			 this->minGradWeight = _minGradWeight;
			 this->flowCnfScale  = _flowCnfScale;
			 this->flowLenScale  = _flowLenScale;
		}

		static _Params Default();
		void Dump(string prefix);
	}Params;

private:
	Params params;

public:
	GSF_MotionBlur(GS_Problem* _problem, const Params &_params = Params::Default());
	void FilterLevel(int iLevel, void* userData = NULL);

public: //GSF_MotionBlur-Driver.cpp	

	static GS_Problem::Params GS_Problem_Params_Default();
	static GS_Solver::Params GS_Solver_Params_Default();

	static GS_Image MotionBlur(GS_ProblemInput& probInput,
							   Params fltParams              = Params::Default(),
							   GS_Problem::Params probParams = GS_Problem_Params_Default(),
							   GS_Solver::Params solParams   = GS_Solver_Params_Default());


	static void TestFilters(string imgFN, string outDir = "");
};

#endif
