#include "GSF_Relight.h"


GSF_Relight::Params GSF_Relight::Params::Default()
{
	return Params(45, 1.0f,
				  FVector2(0, 0), false,
				  LT_DEFAULT);
}

void GSF_Relight::Params::Dump(string prefix)
{
	const char* prefixPtr = prefix.c_str();

	printf("\n");
	printf("%s GSF Relight params:\n", prefixPtr);
	switch(this->lightType)
	{
		case LT_DIRC:
			printf("%s   lighting direction ang: %f\n", prefixPtr, this->lightDircAng);
			break;

		case LT_POINT:
			printf("%s   light point: [%f,%f]\n", prefixPtr, this->lightPoint[0], this->lightPoint[1]);
			printf("%s   light point inverted: %i\n", prefixPtr, this->lightPointInv);
			break;

		default:
			printf("Unknown light type - %i\n", this->lightType);
			break;
	}

	printf("\n");
}
