#include "GSF_Sharpen.h"

GSF_Sharpen::Params GSF_Sharpen::Params::Default()
{
	return Params(2.0f);
}

GSF_Sharpen::Params GSF_Sharpen::Params::Blur()
{
	return Params(0.5f);
}

GSF_Sharpen::Params GSF_Sharpen::Params::Interpolate(const _Params &left, const _Params &right, float middleFrac)
{
	float multiplier = left.multiplier + ((right.multiplier - left.multiplier) * middleFrac);
	return Params(multiplier);
}

void GSF_Sharpen::Params::Dump(string prefix)
{
	const char* prefixPtr = prefix.c_str();

	printf("\n");
	printf("%s GSF Sharpen params:\n", prefixPtr);
	printf("%s  amount - %f\n", prefixPtr, this->multiplier);
	printf("\n");
}


