#ifndef __GSF_TONE_MAP_BLUR_H__
#define __GSF_TONE_MAP_BLUR_H__

#include "GS_Filter.h"

class GSF_ToneMap : public GS_Filter
{
public:
	typedef struct _Params 
	{
		float attenFuncScale, attenFuncExp;
		int minLevelSize;
		_Params(float _attenFuncScale = 0.1f, float _attenFuncExp = 0.9f, int _minLevelSize = 32)
		{
			this->attenFuncScale = _attenFuncScale;
			this->attenFuncExp   = _attenFuncExp;
			this->minLevelSize   = _minLevelSize;
		}
		static _Params Default();
		void Dump(string prefix);
	}Params;

private:
	Params params;

public:
	GSF_ToneMap(GS_Problem *_problem, const Params& _params = Params::Default());
	void FilterLevel(int iLevel, void* userData = NULL);
	void getAttentuationImg(const GS_Image& img, int iLevel, 
							const Params* levelParams, GS_Image& attentuationImg, float avgGradMag = 0.0f);

	float genGradData(const GS_Image& img, int iLevel, GS_Image& imgGradMag);

	GS_Image getWeightImg(const GS_Image& imgGradMag, const Params* levelParams, float avgGradMag);

	Params GetParams()
	{
		return this->params;
	}

public: //GSF_MotionBlur-Driver.cpp	

	static GS_Problem::Params GS_Problem_Params_Default();
	static GS_Solver::Params GS_Solver_Params_Default();

	static GS_Image ToneMap(GS_ProblemInput probInput,
						    Params fltParams              = Params::Default(),
							GS_Problem::Params probParams = GS_Problem_Params_Default(),
							GS_Solver::Params solParams   = GS_Solver_Params_Default());

	static void TestFilters(string imgFN, string outDir = "");
};

#endif

