#ifndef __PRECOND_HBF__
#define __PRECOND_HBF__

#include "AbsractPreconditioner.h"

// implement of the preconditioner described in 
// "Fast Surface Reconstruction Using the Level Set Method"

class PrecondHBF : public AbsractPreconditioner
{
	int width, height, nodeCount, levels;

public:
	PrecondHBF(int _width, int _height, int _levels = -1);
	void Apply(int n, precise* vec) const
	{
		INSIST(n == this->nodeCount);
		//sweepUp(vec); sweepDown(vec);
	}
	
private:
	static int guessNumberOfLevels(int _width, int _height);	
	void sweepUp(precise* vec) const;
	void sweepDown(precise* vec) const;
	void sweepUp(precise* vec, int level) const;
	void sweepDown(precise* vec, int level) const;

	int nodeIndex(int x, int y) const
	{
		return (this->width * y) + x;
	}
};

#endif