#include "SparseSqrSymMat.h"


SparseSqrSymMat::SparseSqrSymMat(int _n)
{
	this->n = _n;
	INSIST(this->matData.size() == 0);
	MatRow emptyRow;
	this->matData.resize(this->n, emptyRow);
}

SparseSqrSymMat::~SparseSqrSymMat()
{
}


void SparseSqrSymMat::Multiply(int inLen, int outLen, 
							   const precise *inVec, precise *outVec) const
{
	INSIST(inLen  == this->n);
	INSIST(outLen == this->n);

	Vec::SetToNull(outLen, outVec);

	int iRow = 0;
	for(vector<MatRow>::const_iterator currRow = this->matData.begin();
		currRow != this->matData.end();
		currRow++, iRow++)
	{			
		for(MatRow::const_iterator currCol = currRow->begin(); 
			currCol != currRow->end(); 
			currCol++)
		{
			int iCol = currCol->first;
			outVec[iRow] += inVec[iCol] * currCol->second;
			if(iCol != iRow)
				outVec[iCol] += inVec[iRow] * currCol->second;
		}
	}
}
