#ifndef __VEC_H__
#define __VEC_H__

#include "Definitions.h"
#include "LinearSolverDefs.h"

class Vec
{

public:

	static void Multiply(int n, precise* vec, precise scalar)
	{
		for(int i = 0; i < n; i++)
		{
			vec[i] *= scalar;
		}
	}

	static precise Multiply(int n, precise* vec1, precise* vec2)
	{		
		precise productSum = 0;	
		for(int i = 0; i < n; i++)
		{			
			productSum += vec1[i] * vec2[i];
		}
		return productSum;
	}

	static void Copy(int n, precise* targetVec, const precise* srcVec)
	{
		memcpy(targetVec, srcVec, sizeof(precise) * n);
	}

	static void AddEqual(int n, precise *sumVec, const precise *vecToAdd)
	{
		for(int i = 0; i < n; i++)
		{
			sumVec[i] += vecToAdd[i];
		}
	}

	static void SetToNull(int n, precise *vec)
	{
		memset(vec, 0, sizeof(precise) * n);
	}


	static void DumpMatlab(int n, precise *vec, char* vecName = "x")
	{
		printf("%s = [ ", vecName);
		for(int i = 0; i < n; i++)
		{
			printf("%1.4e; ", vec[i]);
		}
		printf("]\n");
	}


	static void FillRandValues(int n, precise *vec)
	{
		for(int i = 0; i < n; i++)
		{
			vec[i] = genProb();
		}
	}
};

#endif