#ifndef __LINE_EQ_H__
#define __LINE_EQ_H__

#include "Definitions.h"
#include "Transform-2x2.h"
#include "Image.h"

typedef struct _LineEq
{
	float a, b, c;

	_LineEq(float _a = 0.0f, float _b = 0.0f, float _c = 0.0f)
	{
		this->a = _a;
		this->b = _b;
		this->c = _c;
	}

	_LineEq(float x1, float y1, 
		    float x2, float y2)
	{
		this->a = y2 - y1;
		this->b = x1 - x2;
		this->c = -((x1 * this->a) + (y1 * this->b));
	}

	_LineEq(float x1, float y1, 
	        float x2, float y2, int invertHeight)
	{
		CHECK_RANGE(y1, 0, invertHeight - 1);
		CHECK_RANGE(y2, 0, invertHeight - 1);
		y1 = invertHeight - 1 - y1;
		y2 = invertHeight - 1 - y2;

		*this = _LineEq(x1, y1, x2, y2);
	}

	_LineEq(FVector2 pt1, FVector2 pt2)
	{
		*this = _LineEq(pt1[0], pt1[1], pt2[0], pt2[1]);
	}	
} LineEq;


#endif