#ifndef TIMER_H
#define TIMER_H

#include "Debug.h"
#ifdef WIN32
	#include <time.h>
#else
	#include <sys/time.h>	
#endif

class Timer
{
private:
	double startTime;
    bool ticking;
    double secCount;

	double runningTime()
	{
		ENSURE(ticking == true);
		return getTimeOfDay() - this->startTime;
	}

	double getTimeOfDay()
	{
#ifdef WIN32
		return (double) time(NULL);
#else
		struct timeval currTime;
		gettimeofday(&currTime, NULL);
		return currTime.tv_sec + (currTime.tv_usec / 1000000.0);
#endif
	}

public:
	Timer(bool startNow = true);
	void Start();
	void Restart();
	double Stop();
	double GetSecondsCount();
	void DumpTime(const char *debugStr = "");
	void DumpSeconds(const char *debugStr = "");
};

#endif


