#include "GS_MainWindow.h"
#include "Disk.h"

void GS_MainWindow::file_open()
{
	string fileName = this->wg_fileChooser->GetFileNameChoice( "Open...", Fl_File_Chooser::SINGLE ); 
	file_open(fileName);
}

void GS_MainWindow::file_open(string fileName)
{
	if(fileName.length() > 0)
	{	
		SET_WAIT_CURSOR();
		this->imgData.Load(fileName, this->params.options.fltParams.gspParams);
		SET_DEFAULT_CURSOR();
		view_img();
		setupFilters();
	}
}

void GS_MainWindow::file_saveResult(string fileName)
{
	ImageIO::WriteFile(this->imgData.result, fileName);
}

void GS_MainWindow::file_saveResultAs()
{
	string fileName = this->wg_fileChooser->GetFileNameChoice( "Save as...", Fl_File_Chooser::CREATE, "", true ); 
	if(fileName.compare("") != 0)
	{
		file_saveResult(fileName);
	}
}

void GS_MainWindow::file_exit()
{
	this->hide();
}

void GS_MainWindow::cb_file_open(Fl_Widget*, void* mainWinPtr)
{
	((GS_MainWindow *) mainWinPtr)->file_open();
}


void GS_MainWindow::cb_file_saveResultAs(Fl_Widget*, void* mainWinPtr)
{
	((GS_MainWindow *) mainWinPtr)->file_saveResultAs();
}

void GS_MainWindow::cb_file_exit(Fl_Widget*, void* mainWinPtr)
{
	((GS_MainWindow *) mainWinPtr)->file_exit();
}
