#ifndef __GS_SCURVE_VIS_H__
#define __GS_SCURVE_VIS_H__

#include "Definitions.h"
#include "GS_UI_Definitions.h"
#include "GS_FuncVis.h"

/*
 * Inheriting from Fl_Button instead of Fl_Box because we want GS_Curve_Vis 
 * to be able to take focus
 */
class GS_Curve_Vis : public Fl_Button
{

private:
	int selectedPtIndex;
	const Curve *curve;

	GS_FuncVis::GS_FuncVisParams funcVisParams;

public:
	GS_Curve_Vis(const Curve *_curvePoints);
	void UpdateParams(int selectedPointIndex);
	void draw();	
	GS_Line GetGraphDiag();
	int handle(int eventID);

private:
	void updateFuncVisParams();
	void drawCurvePoints(const GS_Line &graphDiag);
};

#endif